=== debian/changelog ===
lima (1.3.0) unstable; urgency=low

  * first version

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Thu,  3 Aug 2006 19:16:22 +0100
